import{SmartRenderer}from'../../../../fc-core/src/component-interface';import SRSTool from'./srs-tool';import{Separator}from'../../../../fc-core/src/toolbox/tools';import{SymbolStore,bottomPath}from'../../../../fc-core/src/toolbox/tools/helper';import{extend2,DEFAULT_FT_FONT}from'../../../../fc-core/src/lib';import{ToolBar}from'../../../../fc-core/src/toolbox';import{utcMinute,utcHour,utcDay,utcWeek,utcMonth,utcYear}from'../../../../fc-utils/src/time-intervals/utc';import{timeMinute,timeHour,timeDay,timeWeek,timeMonth,timeYear}from'../../../../fc-utils/src/time-intervals';const DURATION_YEAR=31536e6,DURATION_MONTH=26784e5,DURATION_DAY=864e5,DURATION_HOUR=36e5,COLOR_9E9E9E='#9e9e9e',COLOR_5F5F5F='#5f5f5f',COLOR_DFDFDF='#dfdfdf',standardIntervals=[31536000000,16070400000,8035200000,2678400000,1296000000,604800000,86400000,43200000,21600000,10800000,3600000,1800000],intervalMap={0:{unit:'year',multiplier:1,intervalName:'1Y',tilldateName:'YTD'},1:{unit:'month',multiplier:6,intervalName:'6M'},2:{unit:'month',multiplier:3,intervalName:'3M',tilldateName:'QTD'},3:{unit:'month',multiplier:1,intervalName:'1M',tilldateName:'MTD'},4:{unit:'day',multiplier:15,intervalName:'15D'},5:{unit:'day',multiplier:7,intervalName:'7D',tilldateName:'WTD'},6:{unit:'day',multiplier:1,intervalName:'1D'},7:{unit:'hour',multiplier:12,intervalName:'12H'},8:{unit:'hour',multiplier:6,intervalName:'6H'},9:{unit:'hour',multiplier:3,intervalName:'3H'},10:{unit:'hour',multiplier:1,intervalName:'1H'},11:{unit:'minute',multiplier:30,intervalName:'30m'}},stateStyle={activated:{config:{hover:{fill:'none',labelFill:'#5648D4',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',stroke:'none',"symbol-stroke":'none',"stroke-width":2,cursor:'pointer',"stroke-opacity":1},normal:{fill:'none',labelFill:'#9e9e9e',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',stroke:'none',"symbol-stroke":'none',"stroke-width":2,cursor:'pointer',"stroke-opacity":1},disable:{fill:'none',labelFill:'#9e9e9e',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',stroke:'none',"symbol-stroke":'none',"stroke-width":2,cursor:'pointer',"stroke-opacity":1}},"button-disabled":!1,fill:'none',labelFill:'#9e9e9e',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',stroke:'none',"symbol-stroke":'none',"stroke-width":2,cursor:'pointer',"stroke-opacity":1},pressed:{config:{hover:{fill:'none',labelFill:'#5648D4',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',"stroke-width":2,stroke:'none',"symbol-stroke":'#5648D4',cursor:'pointer'},normal:{fill:'none',labelFill:'#5648D4',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',"stroke-width":2,stroke:'none',"symbol-stroke":'#343434',cursor:'pointer'}},fill:'none',labelFill:'#5f5f5f',symbolFill:'none',hoverFill:'none',"fill-symbol":'none',"stroke-width":2,stroke:'none',"symbol-stroke":'#343434',"symbol-stroke-width":2,cursor:'pointer'}},isValidInterVal=function(a,b,c,d=!1,e){let f=this,g=getInterVal(intervalMap[a].unit,f.getFromEnv('isUTC')),h=3*c[2];return!!(standardIntervals[a]>=b[2]&&(d?e-g.every(intervalMap[a].multiplier).floor(e)>=h:standardIntervals[a]>=3*c[2]))},getHighlightedIntervalButton=function(a){let b,c=standardIntervals.length,d={};for(b=c-1;0<=b&&standardIntervals[b]!==a;b--);return-1!==b&&(d=extend2({isIntervalButton:!0},intervalMap[b])),d},getIntervalButtons=function(a,b,c,d){let e,f=standardIntervals.length,g=[];for(e=f-1;0<e&&!(standardIntervals[e]>=a);e--);return a&&(0>=e?(standardIntervals[0]<=b&&isValidInterVal.call(this,0,c,d)&&g.push(intervalMap[0]),standardIntervals[1]<=b&&isValidInterVal.call(this,1,c,d)&&g.push(intervalMap[1])):e===f-1?(standardIntervals[e-1]<=b&&isValidInterVal.call(this,e-1,c,d)&&g.push(intervalMap[e-1]),standardIntervals[e]<=b&&isValidInterVal.call(this,e,c,d)&&g.push(intervalMap[e])):(standardIntervals[e-1]<=b&&isValidInterVal.call(this,e-1,c,d)&&g.push(intervalMap[e-1]),standardIntervals[e]<=b&&isValidInterVal.call(this,e,c,d)&&g.push(intervalMap[e]),standardIntervals[e+1]<=b&&isValidInterVal.call(this,e+1,c,d)&&g.push(intervalMap[e+1]))),g},getTillDateButtons=function(a,b,c){let d,e,f,g=[],h=this.getFromEnv('chartConfig').contextLimit[1],j=new Date(h),k=new Date;if(j.getYear()===k.getYear()&&j.getMonth()===k.getMonth()&&j.getDate()===k.getDate())for(e=0,f=standardIntervals.length;e<f;e++)a>=standardIntervals[e]&&intervalMap[e].tilldateName&&isValidInterVal.call(this,e,b,c,!0,h)&&(d=extend2({},intervalMap[e]),d.fixedAtEnd=!0,d.fixedAtStart=!1,g.push(d));return g},getInterVal=function(a,b){return'year'===a?b?utcYear:timeYear:'quarter'===a?b?utcMonth:timeMonth:'month'===a?b?utcMonth:timeMonth:'week'===a?b?utcWeek:timeWeek:'day'===a?b?utcDay:timeDay:'hour'===a?b?utcHour:timeHour:'minute'===a?b?utcMinute:timeMinute:void 0};class StandardRangeSelector extends SmartRenderer{constructor(){super();let a=this;this._handler=function(){let b,c,d,e=this,f=e.getFromEnv('chart'),g=e.config.multiplier,h=e.getFromEnv('isUTC'),i=e.config.unit,j=e.config.fixedAtEnd,k=e.config.fixedAtStart,l=f.getFocusLimit(),m=f.getContextLimit();a.config.clickedButtonDetails=e.config,e.getFromEnv('animationManager').setAnimationState('selectedRange'),d=j?m[1]:l[1],i&&g?(b=getInterVal(i,h),c=j?b.every(g).floor(d):b.offset(d,-g)):k&&(c=m[0]),a.config.lastClickedButtonConfig={fixedAtEnd:e.config.fixedAtEnd,fixedAtStart:e.config.fixedAtStart,unit:e.config.unit,multiplier:e.config.multiplier},a.config.updatedThroughButton=!0,f.setFocusLimit([c,d])},this._toolbars={}}__setDefaultConfig(){super.__setDefaultConfig(),this.config.lastClickedButtonConfig=void 0,this.config.clickedButtonDetails={},this.config.intervalButton=[],this.config.tillDateButton=[],this.config.separators=[],this.config.allButton=void 0,this.config.labelFontSize='12px'}configureAttributes(a){super.configureAttributes(a);let b=this.config,c=this.getFromEnv('chart');for(let d in b.contextRangeThreshold=c.getFromEnv('contextScalesX')[0].getRangeThreshold(),b.focusRangeThreshold=c.getFromEnv('focusScalesX')[0].getRangeThreshold(),b.contextMinBin=c.getFromEnv('contextScalesX')[0].getBinMin(),b.focusMinBin=c.getFromEnv('focusScalesX')[0].getBinMin(),a)a.hasOwnProperty(d)&&(b[d]=a[d]);this.createAllButtons()}getSelectionButtonConfig(){let a,b,c,d=this,e=d.config,f=d.getFromEnv('isUTC'),g=e.currentDomain,h={},i=e.totalDomain;return b=f?utcYear:timeYear,a=f?utcMonth:timeMonth,c=f?utcDay:timeDay,e.lastClickedButtonConfig?(h={isTillDate:e.lastClickedButtonConfig.fixedAtEnd&&!e.lastClickedButtonConfig.fixedAtStart,isAllButton:e.lastClickedButtonConfig.fixedAtEnd&&e.lastClickedButtonConfig.fixedAtStart,isIntervalButton:!e.lastClickedButtonConfig.fixedAtEnd&&!e.lastClickedButtonConfig.fixedAtStart,multiplier:e.lastClickedButtonConfig.multiplier,unit:e.lastClickedButtonConfig.unit},h):+g[1]-+g[0]==+i[1]-+i[0]?{isAllButton:!0}:+g[1]-+g[0]==+g[1]-+b.floor(g[1])?{isTillDate:!0,multiplier:'1',unit:'year'}:+g[1]-+g[0]==+g[1]-+a.floor(g[1])?{isTillDate:!0,multiplier:'1',unit:'month'}:+g[1]-+g[0]==+g[1]-+a.every(3).floor(g[1])?{isTillDate:!0,multiplier:'3',unit:'month'}:+g[1]-+g[0]==+g[1]-+c.every(7).floor(g[1])?{isTillDate:!0,multiplier:'7',unit:'day'}:getHighlightedIntervalButton(+g[1]-+g[0])}getToolBar(a){return this._toolbars[a]}setToolBar(a,b){this._toolbars[a]=b}createAllButtons(){let a,b,c,d,e,f=this.config,g=f.currentDomain,h=this.getFromEnv('chart'),j=this.getToolBar('contextToolBar'),k=this.getToolBar('businessToolBar'),l=this.getToolBar('allToolBar'),m=h.getContextLimit(),n=this.getFromEnv('selectorToolbar'),o=f.contextRangeThreshold,p=f.focusRangeThreshold,q=f.contextMinBin,r=f.focusMinBin,s=this.getFromEnv('smartLabel'),t=f.allButton,u=f.intervalButton,v=f.tillDateButton,w=f.separators,x=getIntervalButtons.call(this,+g[1]-+g[0],+m[1]-+m[0],p,r),y=getTillDateButtons.call(this,+m[1]-+m[0],o,q);for(s.setStyle({fontSize:f.labelFontSize,fontFamily:DEFAULT_FT_FONT,fontWeight:400}),SymbolStore.register('interval',bottomPath),c=this.getSelectionButtonConfig(),j||(j=n.attachChild(ToolBar,'tool',`contextToolBar-${n.getId()}-${h.getId()}`),j.configure({hAlign:'left',toolbarhdirection:1}),j.setState('visible',!0),this.setToolBar('contextToolBar',j)),(d=0,e=x.length);d<e;d++)b=c.isIntervalButton&&c.unit===x[d].unit&&c.multiplier===x[d].multiplier?'pressed':'activated',u[d]?u[d].config.text===x[d].intervalName?a={width:u[d].config.width}:a=s.getSmartText(x[d].intervalName):(u[d]=j.attachChild(SRSTool,'tool',`intervalButton-${n.getId()}-${h.getId()}-${d}`),u[d].addEventListener('fc-click',this._handler),a=s.getSmartText(x[d].intervalName),j.asyncDraw()),u[d].configure({text:x[d].intervalName,name:'interval',width:a.width,scale:1,marginLeft:d?5:0,marginRight:d===e-1?0:5,hAlign:'left',symbolStrokeWidth:'2',labelFontSize:f.labelFontSize,stateStyle:stateStyle,hoveredState:'normal',state:b,labelFontFamily:DEFAULT_FT_FONT,multiplier:x[d].multiplier,unit:x[d].unit,strokeWidth:0}),u[d].show();if(u.length>d)for(d;d<u.length;d++)u[d].hide();for(x.length?(!w[0]&&(w[0]=n.attachChild(Separator,'tool',`separator-${n.getId()}-${h.getId()}-0`)),w[0].configure({marginLeft:0,marginRight:0,scale:1,height:16,width:10,hAlign:'left',stroke:COLOR_DFDFDF}),w[0].show()):w[0]&&w[0].hide(),k||(k=n.attachChild(ToolBar,'tool',`businessToolBar-${n.getId()}-${h.getId()}`),k.configure({hAlign:'left',toolbarhdirection:1}),k.setState('visible',!0),this.setToolBar('businessToolBar',k)),(d=0,e=y.length);d<e;d++)b=c.isTillDate&&c.unit===y[d].unit&&c.multiplier===y[d].multiplier?'pressed':'activated',v[d]?v[d].config.text===y[d].tilldateName?a={width:v[d].config.width}:a=s.getSmartText(y[d].tilldateName):(v[d]=k.attachChild(SRSTool,'tool',`tillDateButton-${n.getId()}-${h.getId()}-${d}`),v[d].addEventListener('fc-click',this._handler),a=s.getSmartText(y[d].tilldateName),k.asyncDraw()),v[d].configure({text:y[d].tilldateName,name:'interval',scale:1,width:a.width,stateStyle:stateStyle,state:b,multiplier:y[d].multiplier,unit:y[d].unit,symbolStrokeWidth:'2',hoveredState:'normal',labelFontSize:f.labelFontSize,labelFontFamily:DEFAULT_FT_FONT,fixedAtStart:y[d].fixedAtStart,fixedAtEnd:y[d].fixedAtEnd,marginLeft:d?5:0,marginRight:d===e-1?0:5,hAlign:'left',strokeWidth:0});y.length?(!w[1]&&(w[1]=n.attachChild(Separator,'tool',`separator-${n.getId()}-${h.getId()}-1`)),w[1].configure({marginLeft:0,marginRight:0,scale:1,height:16,classIndex:3,itemIndex:0,width:10,hAlign:'left',stroke:COLOR_DFDFDF}),w[1].show()):w[1]&&w[1].hide(),b=c.isAllButton?'pressed':'activated',l||(l=n.attachChild(ToolBar,'tool',`allToolBar-${n.getId()}-${h.getId()}`),l.configure({hAlign:'left',toolbarhdirection:1}),l.setState('visible',!0),this.setToolBar('allToolBar',l)),t?a={width:t.config.width}:(f.allButton=t=l.attachChild(SRSTool,'tool',`allButton-${n.getId()}-${h.getId()}-0`),t.addEventListener('fc-click',this._handler),a=s.getSmartText('All'),l.asyncDraw()),t.configure({state:b,width:a.width,scale:1,stateStyle:stateStyle,labelFontSize:f.labelFontSize,text:'All',name:'interval',marginLeft:0,marginRight:0,hAlign:'left',hoveredState:'normal',symbolStrokeWidth:'2',labelFontFamily:DEFAULT_FT_FONT,strokeWidth:0,fixedAtStart:!0,fixedAtEnd:!0,fill:'#00ff00',labelFill:'#00ff00',symbolFill:'#00ff00'}),n.asyncDraw()}}export default StandardRangeSelector;